# -*- coding:Utf-8 -*-
import re
import es
import random
import langlib
import votelib
import popuplib
import playerlib
import gamethread
import psyco
psyco.full()
 
sici_rtv = es.AddonInfo()
sici_rtv.version = "1.1"
sici_rtv.auteur = "Sicilia"
sici_rtv.name = "Sici_Rtv"
sici_rtv.description = "Une alternative au rtv"
sici_rtv.url = "http://addons.eventscripts.com/addons/user/22862"
sici_rtv.sponsor = "www.fog.asso.fr"
sici_rtv.date = "19.02.2009"


es.ServerVar(sici_rtv.name, sici_rtv.version, sici_rtv.description).makepublic()

class File(object):
    def __init__(self):
        self._line = []
 
    def __loop(self):
        index = 0
        while index < len(self._line):
            self._line[index] = re.sub('//.*|^(( |\t)+)|(( |\t)+)$|(\r)+|(\t)+|(\n)+|(")+|', "", self._line[index])
            if not self._line[index]: del(self._line[index])
            else: index += 1
 
    def read(self, pathern = ""):
        self._line = []
        if not pathern: return self._line[:]
        else:
            try:
                line = open(pathern, "r")
                self._line = line.readlines()
                self.__loop()
            except IOError: self._line = []
            finally:
                line.close()
                return self._line[:]

def load():
    es.server.cmd("es_xmexec sici_rtv/config.cfg")
    es.msg("#multi", "#lightgreen[#greenRtV#lightgreen] #green Script By #lightgreenSicilia #green[Fog.asso.fr].")
    ok_rtv()
    map_vote()

def unload():
    sici_vote.delete()
    sici_nominate.delete()

def submit(userid, votename, choice, choicename):
    name = es.getplayername(userid)
    player_vote.append(es.getplayersteamid(userid))
    for player in es.getUseridList():
        es.tell(player,'#multi',sici_lang('choix',{'noms_choix': choicename,'joueur': name},playerlib.getPlayer(player).get('lang')))

def finish(votename, win, winname, winvotes, winpercent, total, tie, cancelled):

    global can_rtv
    can_rtv = False
    if total == 0:
        ok_rtv()
        map_vote()
        for userid in es.getUseridList():
            es.tell(userid,'#multi',sici_lang('annuler', lang = playerlib.getPlayer(userid).get('lang')))

    else:
        for userid in es.getUseridList():
            es.tell(userid,'#multi',sici_lang('gagne',{'maps': winname,'temps_changemaps': sici_changemaps_temps},playerlib.getPlayer(userid).get('lang')))
            es.delayed(sici_changemaps_temps, "changelevel %s" % winname)

def player_say(ev):
    if ev["text"] == "nominate":
        if votelib.isrunning("sici_rtv"):
            es.tell(ev["userid"],'#multi',sici_lang('fini_nominate', lang = playerlib.getPlayer(ev["userid"]).get('lang')))
        elif len(player_nominate) < int(sici_nominations):
            if not player_nominate.has_key(ev["es_steamid"]):
                if not popuplib.isqueued("sici_nominate", ev["userid"]):
                    sici_nominate.send(ev["userid"])

            else:
                es.tell(ev["userid"],'#multi',sici_lang('deja_nominate', lang = playerlib.getPlayer(ev["userid"]).get('lang')))

        else:
            es.tell(ev["userid"],'#multi',sici_lang('trop_nominate',{'nomination': sici_nominations},playerlib.getPlayer(ev["userid"]).get('lang')))

    elif ev["text"] == "rtv":
        if int(100/(float(es.getmaxplayercount())/len(playerlib.getUseridList("#human")))) < int(sici_req_s_p):
            es.tell(ev["userid"],'#multi',sici_lang('insuffisant', lang = playerlib.getPlayer(ev["userid"]).get('lang')))

        elif not can_rtv:
            es.tell(ev["userid"],'#multi',sici_lang('att_debut',{'temps': decompte},playerlib.getPlayer(ev["userid"]).get('lang')))

        elif votelib.isrunning("sici_rtv"):
            if ev["es_steamid"] in player_vote:
                es.tell(ev["userid"], '#multi',sici_lang('deja_vote', lang = playerlib.getPlayer(ev["userid"]).get('lang')))

            else:
                if popuplib.active(ev["userid"])["name"] == "0":
                    sici_vote.send(ev["userid"])

        else:
            if ev["es_steamid"] in player_rtv:
                es.tell(ev["userid"],'#multi',sici_lang('deja_rtv', lang = playerlib.getPlayer(ev["userid"]).get('lang')))

            else:
                player_rtv.append(ev["es_steamid"])
                if len(player_rtv) == 1:
                    for user_rtv in es.getUseridList():
                        es.tell(user_rtv,'#multi',sici_lang('rtv',{"player" : ev["es_username"]}, playerlib.getPlayer(user_rtv).get('lang')))

            nombre_humain = len(playerlib.getUseridList("#human"))
            nombre_rtv = len(player_rtv)
            pourcentage_requis = int(sici_rtv_p_req)
            pourcentage_actuelle = 100/(float(nombre_humain)/nombre_rtv)
            pourcentage_manquant = pourcentage_requis - int(pourcentage_actuelle)

            nombre_reelle = (nombre_humain * float(pourcentage_manquant)) / 100
            nombre_entier = int(nombre_reelle)
            
            if nombre_reelle > float(nombre_entier):
                nombre_entier += 1

            if nombre_entier:
                for user_rtva in es.getUseridList():
                    es.tell(user_rtva,"#multi",sici_lang('restant',{'joueur': ev["es_username"],'vote_restant': str(nombre_entier)}, playerlib.getPlayer(user_rtva).get('lang')))
            
            if int(pourcentage_actuelle) >= pourcentage_requis:
                set_vote()
                sici_vote.start(30)
                sici_nominate.unsend(es.getUseridList())
                for user_rtvo in es.getUseridList():
                    es.tell(user_rtvo,"#multi",sici_lang('start', lang = playerlib.getPlayer(user_rtvo).get('lang')))           

def ok_rtv():
    global can_rtv, player_rtv, player_vote, player_nominate
    can_rtv = True
    player_rtv = []
    player_vote = []
    player_nominate = {}

def map_nominate(userid, choix, popupnom):
    name = es.getplayername(userid)
    if len(player_nominate) < int(sici_nominations):
        player_nominate[es.getplayersteamid(userid)] = choix
        for user_rtve in es.getUseridList():
            es.tell(user_rtve,'#multi',sici_lang('choix_nominate',{'nominate_choix': choix ,'joueur': name},playerlib.getPlayer(user_rtve).get('lang')))

    else:
        es.tell(userid,'#multi',sici_lang('trop_nominate',{'nomination': str(len(sici_nominate))},playerlib.getPlayer(userid).get('lang')))
        
def map_vote():
    global sici_vote, sici_nominate, map_liste
    if int(maplist_dir) == 1:
        map_liste = read_file.read("%s/cfg/sici_rtv/maplist.txt" % es.ServerVar("eventscripts_gamedir"))
    elif int(maplist_dir) == 0:
        map_liste = read_file.read("%s/maplist.txt" % es.ServerVar("eventscripts_gamedir"))
    for mapsname in maps_jouer:
        if mapsname in map_liste:
            if len(map_liste) > 1:
                map_liste.remove(mapsname)
            else:
                break

    if votelib.exists("sici_rtv"):
        sici_vote.delete()
    sici_vote = votelib.create("sici_rtv", finish, submit)
    sici_vote.setquestion("RtV : Choisit une map / Choose a map")

    sici_nominate = popuplib.easymenu("sici_nominate", None, map_nominate)
    sici_nominate.settitle("RtV: Nomine une map / Nominate a map")

    for mapname in map_liste:
        sici_nominate.addoption(mapname, mapname)

def set_vote():
    liste_maps_ok = player_nominate.values()
    liste_maps_nb = len(liste_maps_ok)
    
    for mapname in liste_maps_ok:
        if len(map_liste) > 1:
            map_liste.remove(mapname)
        else:
            break

    if not int(sici_maps):
        for mapname in map_liste:
            sici_vote.addoption(mapname)

    elif liste_maps_nb < int(sici_maps):
        for mapname in liste_maps_ok:
            sici_vote.addoption(mapname)

        liste_maps_mq = int(sici_maps) - liste_maps_nb
        if len(map_liste) >= liste_maps_mq:
            for mapname in random.sample(map_liste, liste_maps_mq):
                sici_vote.addoption(mapname)

        else:
            for mapname in map_liste:
                sici_vote.addoption(mapname)

    else:
        for mapname in liste_maps_ok:
            sici_vote.addoption(mapname)
def timer():
    global decompte
    decompte -= 1
    if decompte:
        gamethread.delayed(1, timer)
        
def es_map_start(ev):
    es.server.cmd("es_xmexec sici_rtv/config.cfg")
    if not int(sici_temps_avant):
        ok_rtv()
    else:
        gamethread.delayed(int(sici_temps_avant), ok_rtv)
        global decompte
        decompte = int(sici_temps_avant)
        timer() 
    if len(maps_jouer) == int(nbr_maps) and len(maps_jouer) != 0:
        del(maps_jouer[0])
    if not ev["mapname"] in maps_jouer:
        maps_jouer.append(ev["mapname"])
    map_vote()

# Serveur variable
sici_rtv_p_req          = es.ServerVar("vote_rtv_pourcent_requit")
sici_temps_avant        = es.ServerVar("vote_temps_avant_rtv")
sici_nominations        = es.ServerVar("vote_rtv_nombres_de_nominations")
sici_maps               = es.ServerVar("vote_rtv_nombre_de_maps")
sici_req_s_p            = es.ServerVar("vote_rtv_seuil_pourcent")
sici_changemaps_temps   = es.ServerVar("vote_rtv_temps_pour_changemap")
nbr_maps                = es.ServerVar("nombre_de_maps_a_ne_pas_utiliser")
maplist_dir             = es.ServerVar("rtv_use_maplist")

# Python variable
sici_lang = langlib.Strings(es.getAddonPath("sici_rtv") + "/langage.ini")
read_file = File()
maps_jouer = []
